package net.coolsimulations.SurvivalPlus.api;

import net.fabricmc.loader.api.FabricLoader;

public class SPCompatibilityManager {

	private static boolean modGCLoaded;
	private static boolean modShieldLibLoaded;
	private static boolean modRefinedMachineryLoaded;
	private static boolean modBlockusLoaded;
	private static boolean modBambooTweaksLoaded;
	private static boolean modBambooEverythingLoaded;
	private static boolean modBetterBambooLoaded;
	private static boolean modTraverseLoaded;
	private static boolean modTerrestriaLoaded;
	private static boolean modMoreGemsLoaded;
	private static boolean modEasyEmeraldLoaded;
	private static boolean modVanillaEnhancedLoaded;
	private static boolean modRobinsEmeraldLoaded;
	private static boolean modRobinsRubyLoaded;
	private static boolean modRobinsAmethystLoaded;
	private static boolean modSimpleEmeraldLoaded;
	private static boolean modBambooExpandedLoaded;
	private static boolean modMechanixLoaded;
	private static boolean modPulverizerLoaded;
	private static boolean modIndustrialRevolutionLoaded;
	private static boolean modModernIndustrializationLoaded;

	public static final String GCCORE_MODID = "galacticraft";
	public static final String FABRIC_SHIELD_LIB_MODID = "fabricshieldlib";
	public static final String REFINED_MACHINERY_MODID = "refinedmachinery";
	public static final String BLOCKUS_MODID = "blockus";
	public static final String BAMBOO_TWEAKS_MODID = "bambootweaks";
	public static final String BAMBOO_EVERYTHING_MODID = "bambooeverything";
	public static final String BETTER_BAMBOO_MODID = "bamboomod";
	public static final String TRAVERSE_MODID = "traverse";
	public static final String TERRESTRIA_MODID = "terrestria";
	public static final String MORE_GEMS_MODID = "more_gems";
	public static final String EASY_EMERALD_MODID = "emerald_tools";
	public static final String VANILLA_ENHANCED_MODID = "vanillaenhanced";
	public static final String ROBINS_EMERALD_MODID = "emerald_mod";
	public static final String ROBINS_RUBY_MODID = "ruby_mod";
	public static final String ROBINS_AMETHYST_MODID = "amethyst_mod";
	public static final String SIMPLE_EMERALD_MODID = "em";
	public static final String BAMBOO_EXPANDED_MODID = "bambooexpanded";
	public static final String MECHANIX_MODID = "mechanix";
	public static final String PULVERIZER_MODID = "pulverizer_mod";
	public static final String INDUSTRIAL_REVOLUTION_MODID = "indrev";
	public static final String MODERN_INDUSTRIALIZATION_MODID = "modern_industrialization";

	public static void checkForCompatibleMods(){

		if (FabricLoader.getInstance().isModLoaded(GCCORE_MODID))
		{
			SPCompatibilityManager.modGCLoaded = true;
		}
		
		if (FabricLoader.getInstance().isModLoaded(FABRIC_SHIELD_LIB_MODID))
		{
			SPCompatibilityManager.modShieldLibLoaded = true;
		}
		
		if (FabricLoader.getInstance().isModLoaded(REFINED_MACHINERY_MODID))
		{
			SPCompatibilityManager.modRefinedMachineryLoaded = true;
		}
		
		if (FabricLoader.getInstance().isModLoaded(BLOCKUS_MODID))
		{
			SPCompatibilityManager.modBlockusLoaded = true;
		}
		
		if (FabricLoader.getInstance().isModLoaded(BAMBOO_TWEAKS_MODID))
		{
			SPCompatibilityManager.modBambooTweaksLoaded = true;
		}
		
		if (FabricLoader.getInstance().isModLoaded(BAMBOO_EVERYTHING_MODID))
		{
			SPCompatibilityManager.modBambooEverythingLoaded = true;
		}
		
		if (FabricLoader.getInstance().isModLoaded(BETTER_BAMBOO_MODID))
		{
			SPCompatibilityManager.modBetterBambooLoaded = true;
		}
		
		if (FabricLoader.getInstance().isModLoaded(TRAVERSE_MODID))
		{
			SPCompatibilityManager.modTraverseLoaded = true;
		}
		
		if (FabricLoader.getInstance().isModLoaded(TERRESTRIA_MODID))
		{
			SPCompatibilityManager.modTerrestriaLoaded = true;
		}
		
		if (FabricLoader.getInstance().isModLoaded(MORE_GEMS_MODID))
		{
			SPCompatibilityManager.modMoreGemsLoaded = true;
		}
		
		if (FabricLoader.getInstance().isModLoaded(EASY_EMERALD_MODID))
		{
			SPCompatibilityManager.modEasyEmeraldLoaded = true;
		}
		
		if (FabricLoader.getInstance().isModLoaded(VANILLA_ENHANCED_MODID))
		{
			SPCompatibilityManager.modVanillaEnhancedLoaded = true;
		}
		
		if (FabricLoader.getInstance().isModLoaded(ROBINS_EMERALD_MODID))
		{
			SPCompatibilityManager.modRobinsEmeraldLoaded = true;
		}
		
		if (FabricLoader.getInstance().isModLoaded(ROBINS_RUBY_MODID))
		{
			SPCompatibilityManager.modRobinsRubyLoaded = true;
		}
		
		if (FabricLoader.getInstance().isModLoaded(ROBINS_AMETHYST_MODID))
		{
			SPCompatibilityManager.modRobinsAmethystLoaded = true;
		}
		
		if (FabricLoader.getInstance().isModLoaded(SIMPLE_EMERALD_MODID))
		{
			SPCompatibilityManager.modSimpleEmeraldLoaded = true;
		}
		
		if (FabricLoader.getInstance().isModLoaded(BAMBOO_EXPANDED_MODID))
		{
			SPCompatibilityManager.modBambooExpandedLoaded = true;
		}
		
		if (FabricLoader.getInstance().isModLoaded(MECHANIX_MODID))
		{
			SPCompatibilityManager.modMechanixLoaded = true;
		}
		
		if (FabricLoader.getInstance().isModLoaded(PULVERIZER_MODID))
		{
			SPCompatibilityManager.modPulverizerLoaded = true;
		}
		
		if (FabricLoader.getInstance().isModLoaded(INDUSTRIAL_REVOLUTION_MODID))
		{
			SPCompatibilityManager.modIndustrialRevolutionLoaded = true;
		}
		
		if (FabricLoader.getInstance().isModLoaded(MODERN_INDUSTRIALIZATION_MODID))
		{
			SPCompatibilityManager.modModernIndustrializationLoaded = true;
		}
	}

	public static boolean isGCLoaded()
	{
		return SPCompatibilityManager.modGCLoaded;
	}
	
	public static boolean isShieldLibLoaded()
	{
		return SPCompatibilityManager.modShieldLibLoaded;
	}
	
	public static boolean isRefinedMachineryLoaded()
	{
		return SPCompatibilityManager.modRefinedMachineryLoaded;
	}
	
	public static boolean isBlockusLoaded()
	{
		return SPCompatibilityManager.modBlockusLoaded;
	}
	
	public static boolean isBambooTweaksLoaded()
	{
		return SPCompatibilityManager.modBambooTweaksLoaded;
	}
	
	public static boolean isBambooEverythingLoaded()
	{
		return SPCompatibilityManager.modBambooEverythingLoaded;
	}
	
	public static boolean isBetterBambooLoaded()
	{
		return SPCompatibilityManager.modBetterBambooLoaded;
	}
	
	public static boolean isBambooModsLoaded() {
		return isBlockusLoaded() || isBambooTweaksLoaded() || isBambooEverythingLoaded() || isBetterBambooLoaded() || isBambooExpandedModLoaded() || isVanillaEnhancedLoaded();
	}
	
	public static boolean isTraverseLoaded()
	{
		return SPCompatibilityManager.modTraverseLoaded;
	}
	
	public static boolean isTerrestriaLoaded()
	{
		return SPCompatibilityManager.modTerrestriaLoaded;
	}
	
	public static boolean isMoreGemsLoaded()
	{
		return SPCompatibilityManager.modMoreGemsLoaded;
	}
	
	public static boolean isEasyEmeraldLoaded()
	{
		return SPCompatibilityManager.modEasyEmeraldLoaded;
	}
	
	public static boolean isVanillaEnhancedLoaded()
	{
		return SPCompatibilityManager.modVanillaEnhancedLoaded;
	}
	
	public static boolean isRobinsEmeraldLoaded()
	{
		return SPCompatibilityManager.modRobinsEmeraldLoaded;
	}
	
	public static boolean isRobinsRubyLoaded()
	{
		return SPCompatibilityManager.modRobinsRubyLoaded;
	}
	
	public static boolean isRobinsAmethystLoaded()
	{
		return SPCompatibilityManager.modRobinsAmethystLoaded;
	}
	
	public static boolean isSimpleEmeraldLoaded()
	{
		return SPCompatibilityManager.modSimpleEmeraldLoaded;
	}
	
	public static boolean isEmeraldMaterialModsLoaded()
	{
		return isMoreGemsLoaded() || isEasyEmeraldLoaded() || isVanillaEnhancedLoaded() || isRobinsEmeraldLoaded() || isSimpleEmeraldLoaded();
	}
	
	public static boolean isObsidianMaterialModsLoaded()
	{
		return isVanillaEnhancedLoaded() || isEasyEmeraldLoaded();
	}
	
	public static boolean isBambooExpandedModLoaded()
	{
		return SPCompatibilityManager.modBambooExpandedLoaded;
	}
	
	public static boolean isMechanixLoaded()
	{
		return SPCompatibilityManager.modMechanixLoaded;
	}
	
	public static boolean isPulverizerLoaded()
	{
		return SPCompatibilityManager.modPulverizerLoaded;
	}
	
	public static boolean isIndustrialRevolutionLoaded()
	{
		return SPCompatibilityManager.modIndustrialRevolutionLoaded;
	}
	
	public static boolean isModernIndustrializationLoaded()
	{
		return SPCompatibilityManager.modModernIndustrializationLoaded;
	}

}
